# Truth-O-Meter: MAKING ChatGPT TRUTHFUL

## Intro
Despite its capabilities, GPT-4 has similar limitations to earlier GPT models: it is not fully reliable (e.g. can suffer from “hallucinations”) : OpenAI (2023) https://cdn.openai.com/papers/gpt-4.pdf

This project addresses this exact issue. It takes a text generated by GPT and verifies it against the web knowledge. Suspicious phrases and values are highlighted in sample HTML correction files in /html folder 
White paper: https://www.preprints.org/manuscript/202307.1723/v1

It is inspired by the patent 
CORRECTING CONTENT GENERATED BY DEEP LEARNING
https://patents.justia.com/patent/20220284174

Publication number: 20220284174

Abstract: Methods for correcting raw text generated by deep learning techniques is disclosed. The methods may be performed by systems/computing devices described herein. Raw text previously generated by the deep learning techniques may be obtained. A search query can be generated from a raw text sentence of the raw text. The search query is executed against a knowledge base or a corpus of text to obtain a set of search results, the set of search results comprising a plurality of candidate true sentences that can potentially be utilized to correct one or more entities or phrases of the raw text sentence. A candidate true sentence is selected from the plurality and used to correct the raw text sentence. For example, at least one entity or phrase of the candidate true sentence can be used to replace a corresponding entity or phrase of the raw text sentence.

Type: Application

Filed: February 2, 2022

Publication date: September 8, 2022

Applicant: Oracle International Corporation

Inventor: Boris Galitsky

Installation
> pip install truthometer

create subdirectory of working directory with keys: 
>api_keys/apy_keys.csv

Usage

Get text from a clipboard, fact-check it and produce a report. 
Open report in a browser:
>import os
>import webbrowser
>import truthometer
>from pandas.io.clipboard import clipboard_get

>from truthometer.fact_checker_via_web import FactCheckerViaWeb

>fact_checker = FactCheckerViaWeb()
>text = clipboard_get()
>filename = fact_checker.perform_and_report_fact_check_for_text(text)
>path = os.getcwd() + '/'+ filename

>osname = os.name
>if osname == 'posix':
    chrome_path = 'open -a /Applications/Google\ Chrome.app %s'
>elif osname == 'ntt':
    chrome_path = 'C:/Program Files (x86)/Google/Chrome/Application/chrome.exe %s'
>else:
    chrome_path = '/usr/bin/google-chrome %s'

>webbrowser.get(chrome_path).open(path)
